TanStack

Solid Example: CreateAsyncThrottler

import { For, createSignal } from 'solid-js'
import { render } from 'solid-js/web'
import { createAsyncThrottler } from '@tanstack/solid-pacer/async-throttler'

interface SearchResult {
  id: number
  title: string
}

// Simulate API call with fake data
const fakeApi = async (term: string): Promise<Array<SearchResult>> => {
  await new Promise((resolve) => setTimeout(resolve, 500)) // Simulate network delay
  return [
    { id: 1, title: `${term} result ${Math.floor(Math.random() * 100)}` },
    { id: 2, title: `${term} result ${Math.floor(Math.random() * 100)}` },
    { id: 3, title: `${term} result ${Math.floor(Math.random() * 100)}` },
  ]
}

function App() {
  const [searchTerm, setSearchTerm] = createSignal('')
  const [results, setResults] = createSignal<Array<SearchResult>>([])
  const [error, setError] = createSignal<Error | null>(null)

  // The function that will become throttled
  const handleSearch = async (term: string) => {
    if (!term) {
      setResults([])
      return
    }

    // throw new Error('Test error') // you don't have to catch errors here (though you still can). The onError optional handler will catch it

    const data = await fakeApi(term)
    setResults(data) // option 1: set results immediately
    setError(null)

    return data // option 2: return data if you need to
  }

  // hook that gives you an async throttler instance
  const setSearchAsyncThrottler = createAsyncThrottler(
    handleSearch,
    {
      wait: 1000, // Wait 1 second between API calls
      onError: (error) => {
        // optional error handler
        console.error('Search failed:', error)
        setError(error as Error)
        setResults([])
      },
    },
    // Alternative to setSearchAsyncThrottler.Subscribe: pass a selector as 3rd arg to track state and subscribe to updates
    // (state) => state,
  )

  // get and name our throttled function
  const handleSearchThrottled = setSearchAsyncThrottler.maybeExecute

  // instant event handler that calls both the instant local state setter and the throttled function
  async function onSearchChange(e: Event) {
    const newTerm = (e.target as HTMLInputElement).value
    setSearchTerm(newTerm)
    const results = await handleSearchThrottled(newTerm) // optionally await if you need to
    console.log('results', results)
  }

  return (
    <div>
      <h1>TanStack Pacer createAsyncThrottler Example</h1>
      <div>
        <input
          autofocus
          type="search"
          value={searchTerm()}
          onInput={onSearchChange}
          placeholder="Type to search..."
          style={{ width: '100%' }}
          autocomplete="new-password"
        />
      </div>
      {error() && <div>Error: {error()?.message}</div>}
      <div>
        <setSearchAsyncThrottler.Subscribe
          selector={(state) => ({
            successCount: state.successCount,
            isPending: state.isPending,
            isExecuting: state.isExecuting,
          })}
        >
          {(state) => (
            <>
              <p>API calls made: {state().successCount}</p>
              <For each={results()}>{(item) => <li>{item.title}</li>}</For>
              {state().isPending ? (
                <p>Pending...</p>
              ) : state().isExecuting ? (
                <p>Executing...</p>
              ) : null}
            </>
          )}
        </setSearchAsyncThrottler.Subscribe>
      </div>
      <setSearchAsyncThrottler.Subscribe selector={(state) => state}>
        {(state) => (
          <pre style={{ 'margin-top': '20px' }}>
            {JSON.stringify(state(), null, 2)}
          </pre>
        )}
      </setSearchAsyncThrottler.Subscribe>
    </div>
  )
}

render(() => <App />, document.getElementById('root')!)

TanStack

Svelte Example: CreateAsyncThrottler

<script lang="ts">
  import { TanStackDevtools } from '@tanstack/svelte-devtools'
  import { pacerDevtoolsPlugin } from '@tanstack/svelte-pacer-devtools'
  import { createAsyncThrottler } from '@tanstack/svelte-pacer/async-throttler'

  interface SearchResult {
    id: number
    title: string
  }
  // Simulate API call with fake data
  const fakeApi = async (term: string): Promise<Array<SearchResult>> => {
    await new Promise((resolve) => setTimeout(resolve, 500)) // Simulate network delay
    return [
      { id: 1, title: `${term} result ${Math.floor(Math.random() * 100)}` },
      { id: 2, title: `${term} result ${Math.floor(Math.random() * 100)}` },
      { id: 3, title: `${term} result ${Math.floor(Math.random() * 100)}` },
    ]
  }
  let searchTerm = $state('')

  let results = $state<Array<SearchResult>>([])

  let error = $state<Error | null>(null)

  // The function that will become throttled
  const handleSearch = async (term: string) => {
    if (!term) {
      results = []
      return
    }
    // throw new Error('Test error') // you don't have to catch errors here (though you still can). The onError optional handler will catch it
    const data = await fakeApi(term)
    results = data
    error = null
    return data // this could alternatively be a void function without a return
  }

  const setSearchAsyncThrottler = createAsyncThrottler(handleSearch, () => ({
    key: 'createAsyncThrottler',
    // leading: true, // default
    // trailing: true, // default
    wait: 1000, // Wait 1 second between API calls
    onError: (cause) => {
      // optional error handler
      console.error('Search failed:', cause)
      error = cause as Error
      results = []
    },
    // throwOnError: true,
  }))

  // get and name our throttled function
  const handleSearchThrottled = setSearchAsyncThrottler.maybeExecute

  // instant event handler that calls both the instant local state setter and the throttled function
  async function onSearchChange(e: Event) {
    const newTerm = (e.target as HTMLInputElement).value
    searchTerm = newTerm
    const result = await handleSearchThrottled(newTerm) // optionally await if you need to
    console.log('result', result)
  }
</script>

<div>
  <h1>TanStack Pacer createAsyncThrottler Example</h1>
  <div>
    <!-- svelte-ignore a11y_autofocus: Focus the search field in this standalone demo. -->
    <input
      autofocus
      type="search"
      value={searchTerm}
      oninput={onSearchChange}
      placeholder="Type to search..."
      style="width: 100%"
      autocomplete="new-password"
    />
  </div>
  <div style="margin-top: 10px">
    <button onclick={() => setSearchAsyncThrottler.flush()}>Flush</button>
  </div>
  {#if error}<div>
      Error: {error.message}
    </div>{/if}<setSearchAsyncThrottler.Subscribe
    selector={(state) => ({
      isExecuting: state.isExecuting,
      isPending: state.isPending,
      successCount: state.successCount,
    })}
    >{#snippet children({ isExecuting, isPending, successCount })}<div>
        <p>API calls made: {successCount}</p>
        {#if results.length > 0}<ul>
            {#each results as item, index (index)}<li>{item.title}</li>{/each}
          </ul>{/if}{#if isPending}<p>Pending...</p>{:else}{#if isExecuting}<p>
              Executing...
            </p>{:else}{/if}{/if}
      </div>{/snippet}</setSearchAsyncThrottler.Subscribe
  ><setSearchAsyncThrottler.Subscribe selector={(state) => state}
    >{#snippet children(state)}<pre style="margin-top: 20px">{JSON.stringify(
          state,
          null,
          2,
        )}</pre>{/snippet}</setSearchAsyncThrottler.Subscribe
  >
</div>
{#if import.meta.env.DEV}<TanStackDevtools
    plugins={[pacerDevtoolsPlugin()]}
  />{/if}